#!/bin/bash

if [ ! -d .git ]; then
    if [ ! -f src/version ]; then
        echo -e "<?php define(\"APP_VERSION\", \"unknown\");" > src/version
        echo -e "* Version: \e[1munknown\e[0m"
    fi
    exit 0
fi

VERSION="$(git describe --tags)"

if [ -z "$VERSION" ]; then
    echo "Could not parse version from git"
    exit 0
fi

echo -e "<?php define(\"APP_VERSION\", \"$VERSION\");" > src/version
echo -e "* Version: \e[1m$VERSION\e[0m"

