<?php

namespace SparkPlug\Com\Noccy\Docker\Commands\Stack;

use Spark\Commands\Command;
use SparkPlug;
use SparkPlug\Com\Noccy\Docker\Stack\StackManager;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class UnregisterCommand extends Command
{
    protected function configure()
    {
        $this->setName("docker:stack:unregister")
            ->setDescription("Unregister a stack");
        
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $stacks = $this->getStackManager();

        $root = $this->getEnvironment()->getProjectDirectory();
        $stacks->removeStack($root);

        return Command::SUCCESS;
    }

    private function getStackManager(): StackManager
    {
        return new StackManager($this->getEnvironment());
    }
}
