<?php

namespace SparkPlug\Com\Noccy\Pdo\Reflection\Reflector;

use PDO;
use SparkPlug\Com\Noccy\Pdo\PdoResource;
use SparkPlug\Com\Noccy\Pdo\Reflection\ColumnReflectionInterface;

class MysqlColumnReflection implements ColumnReflectionInterface
{

    private array $meta;

    public function __construct(PdoResource $db, array $meta)
    {
        $this->meta = $meta;
    }

    public function isPrimaryKey(): bool
    {
        return str_contains($this->meta['Key']??null, "PRI");
    }

    public function isNullable(): bool
    {
        return ($this->meta['Null']??null) == "YES";
    }

    public function getName(): string
    {
        return $this->meta['Field'];
    }

    public function getType(): string
    {
        return $this->meta['Type'];
    }

    public function getDefaultValue(): mixed
    {
        return $this->meta['Default'] ?? null;
    }

}

