<?php

namespace SparkPlug\Com\Noccy\Pdo\Reflection\Reflector;

use SparkPlug\Com\Noccy\Pdo\PdoResource;
use SparkPlug\Com\Noccy\Pdo\Reflection\DatabaseReflectionInterface;
use SparkPlug\Com\Noccy\Pdo\Reflection\TableReflectionInterface;

class MysqlReflector implements ReflectorInterface
{
    private PdoResource $db;

    public function __construct(PdoResource $db)
    {
        $this->db = $db;
    }

    public function createDatabaseReflection(): DatabaseReflectionInterface
    {
        return new MysqlDatabaseReflection($this->db);
    }

    public function createTableReflection(string $table): TableReflectionInterface
    {
        return new MysqlTableReflection($this->db, $table);
    }


}

