<?php

namespace SparkPlug\Com\Noccy\Pdo\Reflection\Reflector;

use PDO;
use SparkPlug\Com\Noccy\Pdo\PdoResource;
use SparkPlug\Com\Noccy\Pdo\Reflection\ColumnReflectionInterface;

class SqliteColumnReflection implements ColumnReflectionInterface
{

    private array $meta;

    public function __construct(PdoResource $db, array $meta)
    {
        $this->meta = $meta;
    }

    public function isPrimaryKey(): bool
    {
        return (bool)$this->meta['pk'] ?? false;
    }

    public function isNullable(): bool
    {
        return !($this->meta['notnull'] ?? 0);
    }

    public function getName(): string
    {
        return $this->meta['name'];
    }

    public function getType(): string
    {
        return $this->meta['type'];
    }

    public function getDefaultValue(): mixed
    {
        return $this->meta['dflt_value'] ?? null;
    }

}

